
   ASSEMBLER NORMAL ENTRY

MAIN LDYIM $00 RESET
 STY ELO SYMBOL
 LDA SYMBOL TABLE
 STA EHI

   ENTRY WITHOUT SYMBOL TABLE RESET

OLDST JSR MESSY PRINT "PASS 1"
 LDAIM $FF SET PASS = 1
 STAZ PASS

   ENTRY FOR CONTINUATION AT "ID="

IDAS LDYIM $5E
GETID JSR MESSY PRINT "ID="
 INC LOPAR +02
 LDA HIPAR +02 AUTO
 CMP LOPAR +02 ID

 BCC GETIT
 LDA LOPAR +02
 STA ID
 JSR HEXOUT PRINT ID
 JSR CRLF
 JMP NOERID
 
GETIT JSR BUFIN
 LDA BUFFER INPUT
 CMPIM $0D ID
 BNE NENDID
 JMP ENDID

NENDID LDX BUFFER +01
 JSR PACKX     PACK ID
 BNE ERID
 STA LOPAR +02
 STA ID
 LDA BUFFER +02
 CMPIM ',     MORE THAN 1?
 BNE NOERID
 LDA BUFFER +03
 LDX BUFFER +04
 JSR PACKX     PACK ID 2
 STA HIPAR +02
 BEQ NOERID

ERID LDYIM $67 PRINT "?"
 BNE GETID

NOERID LDA ID
 BEQ OKRD
 JSR READ READ FILE

OKRD JSR RESB RESET BLO
 JSR INCBUF
 LDAIM $FF
 STA PCALO OBJECT OUTPUT
 LDA OBJECT RESET
 SEC
 SBCIM $01
 STAZ PCAHI

   ENTRY TO CONTINUE FROM BREAK

ERRTRY LDXIM $FF RESET
 CLI  STACK &
 TXS  IRQ
 LDAIM ERROR
 STA $17FE
 LDAIM ERROR /256
 STA $17FF

 JSR LOAD GET N OF LINE
 STA NHI
 JSR LOAD
 STA NLO
 JSR OUT PUT LINE IN BUFFER

 BMI ASMBLD
 JSR INTRP INTERPRET INPUT SYNTAX

 JSR DECODE DECODE OP
 STA OP
 JSR ADJLTH

 JSR SPECOP CHECK FOR PSEUDO-OP

 LDX PASS
 BNE ONEX
 JSR GETARG INTERPRET ARGUMENT

 JSR RELAD CALCULATE RELATIVE BRANCHES

 JSR PRINT PRINT LINE
 BEQ DNX

ONEX JSR ADDSYM ADD SYMBOL TO TABLE

DNX JSR PCADJ ADJUST PC
 JMP ERRTRY LOPP TO NEXT LINE


ASMBLD LDX PASS 2 = 0
 BNE IDXS

 LDX SAVE
 BNE IDXS
 INC SAVID SAVE
 LDA SAVID OBJECT
 STA ID CODE
 STX SAL
 LDA OBJECT
 STA SAH
 LDA PCALO
 ADCIM $01
 STA EAL
 LDA PCAHI
 ADCIM $00
 STA EAH
 JSR WRITE
 LDA PCLO RESET
 STA SALX OBJECT
 LDA PCHI PARAMETERS
 STA SAHX

IDXS JMP IDAS GET NEXT TAPE

ENDID LDAZ PASS
 BEQ ENDB


