 .EJ
 .BA $4000
 .OC
;
PRINT.TERM .DE $1334
NMI.VECTOR .DE $1A7A
IRQ.VECTOR .DE $1A7E
PIA.PORT.B .DE $1A82
PIA.DIRR.B .DE $1A83
TIM.FLG .DE $1AD5
CLK.1T.DI .DE $1AF7
CLK.64T.EN .DE $1AFE
;
 JMP START 
;
TIM.COUNT .BY $00  
L4004 .BY $00 
L4005 .BY $00 
LETTER .BY $00 $00
L4008 .BY $00
L4009 .BY $00
L400A .BY $00
L400B .BY $00
L400C .BY $00
MORSE .BY $00 $00
COLNR.TERM .BY $00
L4010 .BY $00
;
START LDA PIA.PORT.B
 AND #%11011111
 STA PIA.PORT.B
 LDA PIA.DIRR.B
 ORA #%00100000
 AND #%01111111
 STA PIA.DIRR.B
 LDA #$00
 STA COLNR.TERM
 LDA #L,NMI
 STA NMI.VECTOR
 LDA #H,NMI
 STA NMI.VECTOR+1
 NOP
 NOP
 NOP
 LDA #$81
 STA CLK.1T.DI
L403A BIT TIM.FLG 
 BPL L403A 
 LDY #$00 
 JSR MES.READY 
 LDA #L,TIM.IRQ
 STA IRQ.VECTOR 
 LDA #H,TIM.IRQ
 STA IRQ.VECTOR+1 
L404E LDX #$FF 
 JSR L4122 
L4053 JSR TIM.START 
 JSR L4134 
 INX  
 LDA TIM.COUNT 
 STA L432C,X 
 JSR TIM.START 
 TXA  
 BEQ L4086 
 LDA L432C 
 CMP #$08 
 BPL L4074 
 LDA L432C,X 
 CMP #$08 
 BMI L4086 
L4074 SEC  
 LDA L432C,X 
 SBC L432C 
 BCS L4082 
 EOR #$FF 
 CLC  
 ADC #$01 
L4082 CMP #$05 
 BPL L4097 
L4086 INX  
 CPX #$7F 
 BPL L404E 
 JSR L4122 
 LDA TIM.COUNT 
 STA L432C,X 
 JMP L4053 
;
L4097 LDA L432C,X 
 CMP L432C 
 BPL L40A2 
 LDA L432C 
L40A2 STA L4004 
 STX L4005 
 LDX #$00 
 STX LETTER 
 STX LETTER+1 
L40B0 LDA L432C,X 
 STA L4008 
 JSR L4152 
 JSR L41B2 
 CPX L4005 
 BEQ L40D2 
 INX  
 LDA L432C,X 
 STA L4008 
 JSR L4152 
 JSR L4191 
 INX  
 JMP L40B0 
;
L40D2 LDA TIM.COUNT 
 STA L4008 
 JSR L4152 
 CMP #$18 
 BPL L40F0 
 LDA PIA.PORT.B 
 AND #$80 
 BNE L40D2 
 JSR L425C 
 BNE L40D2 
 JSR L425C 
 BNE L40D2 
L40F0 JSR TIM.START 
 JSR L4191 
L40F6 LDA PIA.PORT.B 
 AND #$80 
 BEQ L4103 
 JSR TIM.START 
 JMP L40F6 
;
L4103 JSR L425C 
 BNE L40F6 
 JSR L425C 
 BNE L40F6 
 JSR L4134 
 LDA TIM.COUNT 
 STA L4008 
 JSR TIM.START 
 JSR L4152 
 JSR L41B2 
 JMP L40D2 
;
L4122 JSR L4266 
 BNE L4122 
 JSR L425C 
 BNE L4122 
 JSR L425C 
 BNE L4122 
 JMP L4266 
;
L4134 JSR L4266 
 BEQ L4134 
 JSR L425C 
 BEQ L4134 
 JSR L425C 
 BEQ L4134 
 JMP L4266 
;
TIM.START LDA #$00 
 STA TIM.COUNT 
 LDA #$9C 
 STA CLK.64T.EN 
 CLI  
 RTS  
;
L4152 STX L4009 
 LDX #$00 
 STX L400A 
 STX L400B 
 LDX #$0C 
L415F CLC  
 LDA L400A 
 ADC L4008 
 STA L400A 
 LDA L400B 
 ADC #$00 
 STA L400B 
 DEX  
 BNE L415F 
 SEC  
L4175 LDA L400A 
 SBC L4004 
 STA L400A 
 LDA L400B 
 SBC #$00 
 STA L400B 
 INX  
 BCS L4175 
 TXA  
 STX L400C 
 LDX L4009 
 RTS  
;
L4191 STX L4009 
 LDA L400C 
 CMP #$0A 
 BMI L41AE 
 CMP #$18 
 BMI L41AB 
 JSR FIGURE 
 SEI  
 JSR L4243 
 CLI  
 LDX L4009 
 RTS  
;
L41AB JSR FIGURE 
L41AE LDX L4009 
 RTS  
;
L41B2 LDA LETTER+1 
 AND #$C0 
 BEQ L41C2 
 LDA #$FF 
 STA LETTER 
 STA LETTER+1 
 RTS  
;
L41C2 LDA L400C 
 CMP #$09 
 BPL L41CE 
 LDA #$02 
 JMP L41D3 
;
L41CE JSR L4212 
 LDA #$01 
L41D3 JSR L421E 
 RTS  
;
FIGURE LDX #'" 
L41D9 JSR GET.MORS.X 
 LDA MORSE 
 CMP LETTER 
 BNE L41EC 
 LDA MORSE+1 
 CMP LETTER+1 
 BEQ L41F3 
L41EC INX  
 CPX #'[ 
 BMI L41D9 
 LDX #$2A 
L41F3 TXA  
 SEI  
 NOP  
 NOP  
 NOP  
 JSR L426C 
 CLI  
 LDX #$00 
 STX LETTER 
 STX LETTER+1 
 RTS  
;
GET.MORS.X LDA TABEL.L-$22,X ;$22='" 
 STA MORSE 
 LDA TABEL.H-$22,X 
 STA MORSE+1 
 RTS  
;
L4212 CLC  
 LDA L4004 
 ADC L4008 
 LSR A 
 STA L4004 
 RTS  
;
L421E LSR A 
 ROL LETTER 
 ROL LETTER+1 
 LSR A 
 ROL LETTER 
 ROL LETTER+1 
 RTS  
;
MES.READY LDA MES.TABLE,Y 
 CMP #$00 
 BEQ MES.RET 
 NOP  
 NOP  
 NOP  
 JSR PRINT.TERM 
 INY  
 JMP MES.READY 
;
MES.RET RTS  
;
NMI SEI  
 JMP START 
;
L4243 LDA #$20 
 NOP  
 NOP  
 NOP  
 JSR L426C 
 RTS  
;
TIM.IRQ PHA  
 LDA #$9C 
 STA CLK.64T.EN 
 INC TIM.COUNT 
 BNE L425A 
 DEC TIM.COUNT 
L425A PLA  
 RTI  
L425C LDA #$7F 
 STA L4010 
L4261 DEC L4010 
 BNE L4261 
L4266 LDA PIA.PORT.B 
 AND #$80 
 RTS  
;
L426C JSR PRINT.TERM 
 INC COLNR.TERM 
 LDA #$3F 
 CMP COLNR.TERM 
 BNE PR.RET 
 LDA #$00 
 STA COLNR.TERM 
 LDA #$0D 
 NOP  
 NOP  
 NOP  
 JSR PRINT.TERM 
 LDA #$0A 
 NOP  
 NOP  
 NOP  
 JSR PRINT.TERM 
PR.RET RTS  
;
 .BY $00  
 .BY $00  
TABEL.L .BY $59
 .BY $55
 .BY $00
 .BY $00  
 .BY $00  
 .BY $A9
 .BY $69
 .BY $A6
 .BY $00
 .BY $00  
 .BY $5A 
 .BY $56 
 .BY $66 
 .BY $59 
 .BY $AA 
 .BY $AA 
 .BY $6A 
 .BY $5A 
 .BY $56 
 .BY $55 
 .BY $55 
 .BY $95 
 .BY $A5 
 .BY $A9 
 .BY $95 
 .BY $99 
 .BY $00 
 .BY $56 
 .BY $00 
 .BY $A5 
 .BY $00
 .BY $06
 .BY $95
 .BY $99
 .BY $25
 .BY $01
 .BY $59
 .BY $29
 .BY $55
 .BY $05
 .BY $6A
 .BY $26
 .BY $65
 .BY $0A
 .BY $09
 .BY $2A
 .BY $69
 .BY $A6
 .BY $19
 .BY $15
 .BY $02
 .BY $16
 .BY $56
 .BY $1A 
 .BY $96 
 .BY $9A 
 .BY $A5 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
;
TABEL.H .BY $06 
 .BY $55 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $06 
 .BY $02 
 .BY $09 
 .BY $00 
 .BY $00 
 .BY $0A 
 .BY $09 
 .BY $06 
 .BY $02 
 .BY $02 
 .BY $01 
 .BY $01 
 .BY $01 
 .BY $01 
 .BY $01 
 .BY $02 
 .BY $02 
 .BY $02 
 .BY $02 
 .BY $0A 
 .BY $09 
 .BY $00 
 .BY $02 
 .BY $00 
 .BY $05 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
 .BY $00 
MES.TABLE .BY $0D $0A $0A $0A
 .BY 'MORSE DECODER'
 .BY $0D $0A $0A
 .BY 'READY'
 .BY $0D $0A $0A
 .BY $00
;
L432C .BY $00  
;
 .EN
