
   OPLEN COMPUTES THE LENGTH OF ANY 6502 INSTR.
   THE INSTR. LENGTH IS SAVED IN BYTES.

OPLEN LDYIM $00
 LDAIY CURADL FETCH OP CODE FROM WS
LENACC LDYIM $01 LENGTH OF OP CODE IS 1 BYTE
 CMPIM $00
 BEQ LENEND BRK INSTRUCTION?
 CMPIM $40
 BEQ LENEND RTI INSTRUCTION?
 CMPIM $60
 BEQ LENEND RTS INSTRUCTION?
 LDYIM $03
 CMPIM $20
 BEQ LENEND JSR INSTRUCTION?
 ANDIM $1F STRIP TO 5 BITS
 CMPIM $19
 BEQ LENEND ANY ABS,Y INSTRUCTION?
 ANDIM $0F STRIP TO 4 BITS
 TAX  USE NIBBLE AS INDEX
 LDYAX LEN FETCH LENGTH FROM LEN
LENEND STY BYTES DISCARD LENGTH IN BYTES
 RTS

   UP MOVES A DATA FIELD BETWEEN CURAD AND CEND
   UPWARD BY THE AMOUNT IN BYTES

UP LDA CURADL
 STA MOVADL
 LDA CURADH MOVAD:=CURAD
 STA MOVADH
UPLOOP LDY BYTES
 LDAIY MOVADL MOVE UPWARD BY THE AMOUNT IN BYTES
 LDYIM $00
 STAIY MOVADL
 INC MOVADL
 BNE UPA
 INC MOVADH MOVADH:=MOVADH+1
UPA LDA MOVADL
 CMP CENDL
 BNE UPLOOP ALL DATA MOVED?
 LDA MOVADH IF NOT, CONTINUE
 CMP CENDH
 BNE UPLOOP
 RTS

   DOWN MOVES A DATA FIELD BETWEEN CURAD
   AND ENDAD DOWNWARD BY THE AMOUNT IN BYTES

DOWN LDA CENDL
 STA MOVADL MOVAD:=CEND
 LDA CENDH
 STA MOVADH
DNLOOP LDYIM $00
 LDAIY MOVADL MOVE DOWNWARD BY THE AM. IN BYTES
 LDY BYTES
 STAIY MOVADL
 LDA MOVADL
 CMP CURADL
 BNE DNA ALL DATA MOVED?
 LDA MOVADH IF NOT, CONTINUE
 CMP CURADH
 BEQ DNEND
DNA SEC
 LDA MOVADL
 SBCIM $01
 STA MOVADL
 LDA MOVADH MOVAD:=MOVAD-1
 SBCIM $00
 STA MOVADH
 JMP DNLOOP
DNEND RTS

   BEGIN SETS CURAD EQUAL TO BEGAD

BEGIN LDA BEGADL
 STA CURADL
 LDA BEGADH CURAD:=BEGAD
 STA CURADH
 RTS


