
      ********* ***********
   ***ASSEMBLER SUBROUTINES***
      ********* ***********

   PEUDO OPERATION DECODE


SPECOP LDA OP
 CMPIM $0C 'ORG'
 BNE NTPC

 LDXIM $05 SET UP
MVTIT LDAZX LABEL TITLE
 STAZX TITLE
 DEX
 BPL MVTIT

 JSR GETARG DECODE ARGUMENT

 LDA OPRH SET UP PC
 STA PCHI
 LDA OPRL
 STA PCLO

LTHX LDAIM $FF LENGTH = 0
 STA LENGTH
 RTS

NTPC CMPIM $80 COMMENT LINE
 BEQ LTHX

 CMPIM $FA * OPERATION
 BEQ LTHX

   ROUTINE TO OPTIMIZE ZERO-PAGE OPS
 
 CMPIM $4C SKIP SOME
 BEQ RTO SPECIAL
 CMPIM $6C OPS
 BEQ RTO

 ANDIM $0C OPTIMIZABLE CODES?
 CMPIM $0C
 BNE RTO

 LDA ARGIN CHECK FOR $XXXX ARGS
 CMPIM '$
 BNE NOTDOL

 LDA ARGIN +01
 ORA ARGIN +02
 CMPIM '0
 BEQ REDUCE
 BNE RTO

NOTDOL LDAIM PARG LOOK UP
 STA SXL SYMBOLIC ARGUMENT
 JSR FNDSBL
 BNE RTO

 INY
 LDAIY SLO ZERO-PAGE?
 BNE RTO

REDUCE LDA OP
 ANDIM $F7 OPTIMIZE
 STA OP
 DEC LENGTH
RTO RTS

   ROUTINE TO PRINT HEX BYTE

HEXR LDX PRFLAG CHECK PRINT FLAG
 BEQ RTO
HEXX JMP HEXOUT

   PRINT ROUTINES WITH PRINT FLAG

FCRLF LDAIM $0D CR AND LF
 BNE FOUTCH

FOUTSP LDAIM $20 SPACE

FOUTCH LDX PRFLAG CHECK FLAG
 BEQ RTO

OUTX JMP OUTCH

   PRINT MESSG(Y) AND CHECK FOR "YES" RESPONSE

YSNO JSR MESSY
 JSR BUFIN
 LDA BUFFER
 CMPIM 'Y
 RTS

   PRINT MESSG(Y)

MESSY LDAAY MESSG
 INY
 CMPIM $40
 BEQ ENDM DO NOT USE
 JSR OUTX PRINT FLAG
 BNE MESSY
ENDM RTS

   ROUTINES TO (RE)SET PRINTER FLAG

PRON LDA PRFLAG
 ANDIM $80 PRINTER OPTION?
 ORA BLFLAG
 STA BLFLAG
 RTS

PROFF LDA BLFLAG
 ANDIM $7F
 STA BLFLAG
 RTS
