
   SUBROUTINE TO PRINT 2 HEX BYTES
   FOLLOWED IMMEDIATELY BY A SPACE

HEXSP JSR HEXAX PRINT 2 HEX BYTES

   SUBROUTINE TO PRINT A SPACE

OUTSP LDAIM '  LOAD SPACE IN A

   SUBROUTINE TO PRINT AN ASCII CHARACTER
   INPUT CHARACTER IS IN THE ACCUMULATOR

OUTCH STY YTMP HIDE Y
 STX XTMP AND X
 CMPIM $0D IS IT A CARRIAGE RETURN?
 BNE NOCR SKIP LF IF NOT

 LDX PMODE CHECK PAGE MODE FLAG
 BNE NOPG SKIP IF NOT ON
 INC COUNTL ADD 1 TO LINES PRINTED
 BNE NOPG SKIP IF NOT END OF SCREEN

 JSR INCH PAUSE UNTIL INPUT OF ANY KEY
 CMPIM $09 WAS HT KEY ENTERED?
 BNE ON IF NOT CONTINUE IN PAGE MODE
 LDAIM $FF TURN OFF PAGE MODE
 STA PMODE

ON LDXIM $F0
 STX COUNTL TO -16

NOPG LDAIM $0A PRINT A LINE FEED
 JSR NOCR (REMOVE IF YOUR TERMINAL
                       HAS AUTO LF)
 LDAIM $0D THIS WAS A CR, REMEMBER
NOCR JSR OUTPUT SO PRINT IT

   ROUTINE TO TEST FOR BREAK DURING I/O

BRKTST BIT PAD TEST INPUT PORT OF PIA
 BPL BREAK IF BIT 7=0

 LDX XTMP SEEK HIDDEN X
 LDY YTMP AND HIDDEN Y
 RTS  AND ITS ALL OVER

BREAK BIT PAD WAIT UNTIL KEY
 BPL BREAK IS RELEASED
 JMP RESTRT THEN GO TO EDITOR

   ROUTINE TO INPUT AN ASCII CHARACTER
   RETURNS IT ACCUMULATOR

INCH STX XTMP HIDE X
 STY YTMP AND Y
 JSR INPUT CALL USER INPUT ROUTINE
 ANDIM $7F STRIP PARITY BIT
 CMPIM $0D WAS INPUT A RETURN
 BNE NOCRIN IF NOT ITS OK

 LDAIM $0A PRINT A LF WITH CR INPUT
 JSR OUTPUT SKIP THIS IF AUTO LF ON TERMINAL
 LDAIM $0D REPLACE CR AGAIN FOR RTS
NOCRIN BNE BRKTST RETURN VIA BREAK TEST
