




   *************************************
   ***** INPUT AND OUTPUT ROUTINES *****
   ***** FOR THE  MICRO-ADE SYSTEM *****
   *************************************


IO ORG $2DC5 77.06.24

BLO * $0010 POINTER TO WORKSPACE
N * $0015 LINE NUMBER
SALX * $0060 FILE EXECUTION ADDRESS
SAHX * $0061
ID * $0062 FILE ID
PMODE * $0063 PAGE MODE FLAG
COUNTL * $0064 LINE COUNT

GANG * $00F0 CWRITE PULSER
TIC * $00F1 CWRITE TIMER
COUNT * $00F2 CWRITE COUNTER
TMP * $00F3 TEMPORARY STORAGE
YTMP * $00F4    "        "
XTMP * $00F5    "        "
TRIB * $00FE CYCLE COUNTER

BUFFER * $0100 INPUT/OUTPUT BUFFER

RESTRT * $2031 EDITOR WARM ENTRY ADDRESS


   KIM ROM AND PIA ADDRESSES

SBD * $1742 PIA LOCATION
CHKL * $17E7 CHECKSUM
CHKH * $17E8
VEB * $17EC VOLATILE EXECUTION BLOCK
SAL * $17F5 TAPE START ADDRESS
SAH * $17F6
EAL * $17F7 TAPE END ADDRESS
EAH * $17F8
INTVEB * $1932 INIT VEB SUBROUTINE
CHKT * $194C CHECK SUM SUBROUTINE
INCVEB * $19EA INCREMENT VEB SUB
RDBYT * $19F3 READ BYTE SUBROUTINE
RDCHT * $1A24 READ CHAR SUBROUTINE
RDBIT * $1A41 READ BIT SUBROUTINE
INIT * $1E8C RESET ALL PIAS







   ******** INPUT AND OUTPUT ROUTINES ********

   SUBROUTINE TO PRINT THE CURRENT LINE NUMBER

NOUT LDA N +01 GET HI N
 LDX N     GET LO N...PRINT THEM

   SUB TO PRINT 2 HEX BYTES
   FIRST BYTE IS IN A
   SECOND BYTE IS IN X

HEXAX JSR HEXOUT PRINT ACCUMULATOR
 TXA  GET BYTE IN X ... PRINT IT

   SUBROUTINE TO PRINT 1 HEX BYTE
   INPUT IS IN ACCUMULATOR

HEXOUT PHA  SAVE INPUT
 LSRA  GET
 LSRA  UPPER
 LSRA  NIBBLE
 LSRA
 JSR HEX PRINT UPPER NIBBLE
 PLA  GET INPUT BACK
 ANDIM $0F GET LOWER NIBBLE

   SUBROUTINE TO PRINT 1 HEX CHARACTER
   INPUT CHAR IS IN ACCUMULATOR

HEX CMPIM $0A LETTER OR NUMBER?
 CLC  CALCULATE ASCII
 BMI HEXA IF IT IS A NUMBER!
 ADCIM $07 ADD 7 TO LETTER
HEXA ADCIM $30 ADD 30 TO BOTH
 BNE OUTCH THEN PRINT IT

   SUBROUTINE TO PRINT A BACKSPACE
   IF YOUR TERMINAL CAN'T-CHANGE THE 5F TO
   ANOTHER CHARACTER TO INDICATE DELETES

BACKSP LDAIM $5F BACKSPACE CHARACTER
 BNE OUTCH PRINT IT

   SUBROUTINE TO PRINT CARRIAGE RETURN
   AND LINE FEED

CRLF LDAIM $0D GET CR CHARACTER
 BNE OUTCH AND PRINT IT


