
      ********* ***********
   ***ASSEMBLER SUBROUTINES***
      ********* ***********

   PEUDO OPERATION DECODE


SPECOP LDA OP
 CMPIM $0C 'ORG'
 BNE NTPC

 LDXIM $05 SET UP
MVTIT LDAZX LABEL TITLE
 STAZX TITLE
 DEX
 BPL MVTIT

 JSR GETARG DECODE ARGUMENT

 LDA OP +02 SET UP
 STA SAHX     PC
 STA PCHI     AND SAVE
 LDA OP +01 FOR ASSEMBLY
 STA SALX
 STA PCLO

LTHX LDAIM $FF LENGTH = 0
 STA LENGTH
 RTS

NTPC CMPIM $80 COMMENT LINE
 BEQ LTHX

 CMPIM $FA * OPERATION
 BEQ LTHX

   ROUTINE TO OPTIMIZE ZERO-PAGE OPS
 
 CMPIM $4C SKIP SOME
 BEQ RTO SPECIAL
 CMPIM $6C OPS
 BEQ RTO

 ANDIM $0C OPTIMIZABLE CODES?
 CMPIM $0C
 BNE RTO

 LDA ARGIN CHECK FOR $XXXX ARGS
 CMPIM $24
 BNE NOTDOL

 LDA ARGIN +01
 ORA ARGIN +02
 CMPIM $30
 BEQ REDUCE
 BNE RTO

NOTDOL LDAIM $38 LOOK UP
 STA SXL SYMBOLIC ARGUMENT
 JSR FNDSBL
 BNE RTO

 INY
 LDAIY SLO ZERO-PAGE?
 BNE RTO

REDUCE LDA OP
 ANDIM $F7 OPTIMIZE
 STA OP
 DEC LENGTH
RTO RTS

   ROUTINE TO PRINT HEX BYTE

HEXR LDX PRFLAG CHECK PRINT FLAG
 BNE RTO
HEXX JMP HEXOUT

   PRINT ROUTINES WITH PRINT FLAG

CRLF LDAIM $0D CR AND LF
 BNE OUTCH

OUTSP LDAIM $20 SPACE

OUTCH LDX PRFLAG CHECK FLAG
 BNE RTO

OUTX JMP OUTK

   PRINT MESSG(Y) AND CHECK FOR "YES" RESPONSE

YSNO JSR MESSY
 JSR BUFIN
 LDA BUFFER
 CMPIM 'Y
 RTS

   PRINT MESSG(Y)

MESSY LDAAY MESSG
 INY
 CMPIM $40
 BEQ ENDM DO NOT USE
 JSR OUTX PRINT FLAG
 BNE MESSY
ENDM RTS


