 .EJ
 .BA $4000
 .OC
 .CE
;
MES.PNT .DE $F8
BUF.PTR .DE $FA
;
;
JUN.PRCHA .DE $1334
JUN.RECCHA .DE $12AE
VIA.TIMER1 .DE $1804
VIA.INTRFL .DE $180D
JUN.NMI .DE $1A7A
JUN.BRKTST .DE $1A7C
PIA.PAD .DE $1A80
PIA.PADD .DE $1A81
PIA.PBD .DE $1A82
PIA.PBDD .DE $1A83
;
;
!!!CRLF .MD
 .BY $0D $0A
 .ME
;
!!!LF .MD
 .BY $0A
 .ME
;
!!!STOP .MD
 .BY 0
 .ME
;
;
;
 JMP RESET 
;
CODE .BY $42
BAUDRATE .BY $01
PBD.BIT .BY %10000000
PAD.BIT .BY %10000000
TIM.TEMP .SE $0000
TIME.L .SE $0000
TIME.H .SE $0000
CHAR .BY $00  
BITS .BY $05
BUF.STRT .SE $4800
BUFF.END .SE $7FFF
BDT.MODE .BY $01
BUFF.FLG .BY $00
OVFLW.FLG .BY $00  
TMP.BF.FLG .BY $00  
AUTO.FLG .BY $00  
COLNR .BY $00  
MAX.COLNR .BY $3F 
BELL.COLNR .BY $35
LIST.LNNR .BY $00
LIST.LN/PG .BY $0B 
SPEED.TBL .SE $55F0 ;45.45 BAUD
 .SE $4E20 ;50
 .SE $4488 ;57
 .SE $3415 ;75
 .SE $2710 ;100
 .SE $2383 ;110
;
 JMP BRK
;
PR/STORE NOP  
 NOP  
 NOP  
 PHA  
 CMP #$00 
 BEQ PR/ST.RET 
 JSR STORE.BUF 
 JSR JUN.PRCHA 
PR/ST.RET PLA  
 RTS  
;
BRK LDA PAD.BIT 
 AND PIA.PAD 
 BEQ BRK 
 LDX #$FF 
 TXS  
 JSR PR.STATE 
 JMP ASK.LIST 
;
ANSWER LDA BUFF.FLG 
 PHA  
 LDA #$00 
 STA BUFF.FLG 
 JSR JUN.RECCHA 
 JSR PR/STORE 
 TAX  
 PLA  
 STA BUFF.FLG 
 TXA  
 RTS  
;
MESSAGE PLA  
 STA *MES.PNT 
 PLA  
 STA *MES.PNT+1 
 LDA BUFF.FLG 
 PHA  
 LDA #$00 
 STA BUFF.FLG 
MES.NXTCHR INC *MES.PNT 
 BNE MES.GETCHR 
 INC *MES.PNT+1 
MES.GETCHR LDY #$00 
 LDA (MES.PNT),Y 
 CMP #$00 
 BEQ MES.RET 
 JSR PR/STORE 
 JMP MES.NXTCHR 
;
MES.RET PLA  
 STA BUFF.FLG 
 LDA *MES.PNT+1 
 PHA  
 LDA *MES.PNT 
 PHA  
 RTS  
;
MSG.BAUDOT JSR MESSAGE 
 CRLF
 .BY 'BAUDOT '
 STOP
 RTS
;
MSG.ASCII JSR MESSAGE 
 CRLF
 .BY 'ASCII '
 STOP
 RTS
;
MSG.RCEIVR JSR MESSAGE 
 .BY 'RECEIVER'
 CRLF
 STOP
 RTS
;
MSG.BAUD JSR MESSAGE 
 .BY ' BAUD'
 CRLF
 STOP
 RTS
;
MSG.45.45 JSR MESSAGE 
 .BY '45.45'
 STOP
 RTS
;
MSG.50 JSR MESSAGE 
 .BY '50'
 STOP
 RTS  
;
MSG.57 JSR MESSAGE 
 .BY '57'
 STOP
 RTS  
;
MSG.75 JSR MESSAGE 
 .BY '75'
 STOP
 RTS
;
MSG.100 JSR MESSAGE 
 .BY '100'
 STOP
 RTS  
;
MSG.110 JSR MESSAGE 
 .BY '110'
 STOP
 RTS  
;
MSG.NO JSR MESSAGE 
 .BY 'NO '
 STOP
 RTS  
;
MSG.STORED JSR MESSAGE 
 CRLF
 .BY 'RECEIVED CHARACTERS ARE'
 CRLF
 .BY 'STORED IN BUFFER'
 CRLF
 STOP
 RTS
;
MSG.AUTOL JSR MESSAGE 
 .BY 'AUTO LETTER MODE'
 STOP
 RTS
;
MSG.CRLF JSR MESSAGE 
 CRLF
 STOP
 RTS  
;
LIST.BUF LDA BUFF.FLG 
 STA TMP.BF.FLG 
 LDA #$00 
 STA BUFF.FLG 
 LDA BUF.STRT 
 LDX BUF.STRT+1 
 CMP *BUF.PTR 
 BNE LIST.STRT 
 CPX *BUF.PTR+1 
 BNE LIST.STRT 
 JSR MESSAGE 
 CRLF
 .BY 'FILE EMPTY'
 CRLF
 STOP
RET.LIST LDA TMP.BF.FLG 
 STA BUFF.FLG 
 RTS  
;
LIST.STRT STA *BUF.PTR 
 STX *BUF.PTR+1 
 JSR MSG.CRLF 
LIST.PAGE LDA #$00 
 STA LIST.LNNR 
LIST.NXT LDY #$00 
 LDA (BUF.PTR),Y 
 CMP #$FF 
 BEQ RET.LIST 
 PHA  
 JSR PR/STORE 
 JSR INC.BF.PTR 
 SEC  
 LDA *BUF.PTR 
 SBC BUFF.END 
 LDA *BUF.PTR+1 
 SBC BUFF.END+1 
 PLA  
 BCC LIST.CR 
MSG.OVRFLW JSR MESSAGE 
 CRLF
 .BY 'FILE OVERFLOW'
 CRLF
 STOP
 RTS
;
LIST.CR CMP #$0D 
 BNE LIST.NXT 
 JSR PR/STORE 
 INC LIST.LNNR 
 LDX LIST.LNNR 
 CPX LIST.LN/PG 
 BCC LIST.LF 
 JSR ANSWER 
 CMP #'E
 BEQ RET.LIST 
 BNE LIST.PAGE 
LIST.LF LDA #$0A 
 CMP (BUF.PTR),Y 
 BEQ LIST.NXT 
 JSR PR/STORE 
 JMP LIST.NXT 
;
INC.BF.PTR INC *BUF.PTR 
 BNE INC.PT.RET 
 INC *BUF.PTR+1 
INC.PT.RET RTS  
;
PR.STATE JSR MSG.CRLF 
 JSR MSG.CRLF 
 LDA CODE 
 CMP #'B
 BNE NOT.BAUDOT 
 JSR MSG.BAUDOT 
 JMP PR.RCVR 
;
NOT.BAUDOT JSR MSG.ASCII 
PR.RCVR JSR MSG.RCEIVR 
 LDA BAUDRATE 
 BNE NOT.45.45 
 JSR MSG.45.45 
 JMP PR.BAUD 
;
NOT.45.45 CMP #$01 
 BNE NOT.50 
 JSR MSG.50 
 JMP PR.BAUD 
;
NOT.50 CMP #$02 
 BNE NOT.57 
 JSR MSG.57 
 JMP PR.BAUD 
;
NOT.57 CMP #$03 
 BNE NOT.75 
 JSR MSG.75 
 JMP PR.BAUD 
;
NOT.75 CMP #$04 
 BNE NOT.100 
 JSR MSG.100 
 JMP PR.BAUD 
;
NOT.100 JSR MSG.110 
PR.BAUD JSR MSG.BAUD 
 LDA BUFF.FLG 
 BEQ PR.NOSTO 
PR.STORED JSR MSG.STORED 
 LDA AUTO.FLG 
 BEQ PR.NOAUTO 
PR.AUTO JSR MSG.AUTOL 
 RTS  
;
PR.NOSTO JSR MSG.NO 
 JMP PR.STORED 
;
PR.NOAUTO JSR MSG.NO 
 JMP PR.AUTO 
;
CONVERT CMP #$1F 
 BEQ SET.LTRS 
 CMP #$1B 
 BEQ SET.FIGS 
 LDX BDT.MODE 
 BEQ GET.FIG 
 TAX  
 LDA LETTERS,X 
 RTS  
;
GET.FIG TAX  
 LDA FIGURES,X 
 RTS  
;
SET.FIGS LDA #$00 
 STA BDT.MODE 
 RTS  
;
SET.LTRS STA BDT.MODE 
 LDA #$00 
 RTS  
;
LETTERS .BY $00  
 .BY 'E'
 .BY $0A
 .BY 'A'
 .BY ' '
 .BY 'S' 
 .BY 'I' 
 .BY 'U' 
 .BY $0D 
 .BY 'D'
 .BY 'R' 
 .BY 'J' 
 .BY 'N' 
 .BY 'F' 
 .BY 'C' 
 .BY 'K' 
 .BY 'T' 
 .BY 'Z'
 .BY 'L' 
 .BY 'W' 
 .BY 'H' 
 .BY 'Y' 
 .BY 'P'
 .BY 'Q'
 .BY 'O' 
 .BY 'B' 
 .BY 'G' 
 .BY $00 
 .BY 'M' 
 .BY 'X' 
 .BY 'V' 
 .BY $00 
FIGURES .BY $00  
 .BY '3' 
 .BY $0A 
 .BY '-' 
 .BY ' ' 
 .BY $27 ;'
 .BY '8' 
 .BY '7' 
 .BY $0D 
 .BY '$' 
 .BY '4' 
 .BY $07 
 .BY ',' 
 .BY $00 
 .BY ':' 
 .BY '(' 
 .BY '5' 
 .BY '+' 
 .BY ')' 
 .BY '2' 
 .BY $00 
 .BY '6' 
 .BY '0' 
 .BY '1' 
 .BY '9' 
 .BY '?' 
 .BY $00 
 .BY $00 
 .BY 'M' 
 .BY 'X' 
 .BY 'V' 
 .BY $00 
RESET JSR INITIALISE 
 LDX #$FF 
 TXS  
 LDA #5
 STA BITS 
 LDA #'B
 STA CODE 
 LDX #$01 
 STX BAUDRATE 
 STX BDT.MODE 
 DEX  
 STX BUFF.FLG 
 STX AUTO.FLG 
 JSR MESSAGE 
 CRLF
 .BY 'ELEKTOR RTTY DECODER'
 CRLF
 LF
 .BY 'BAUDRATE:'
 CRLF
 LF
 .BY '0=45.45 BAUD'
 CRLF
 .BY '1=50'
 CRLF
 .BY '2=57'
 CRLF
 .BY '3=75'
 CRLF
 .BY '4=100'
 CRLF
 .BY '5=110'
 CRLF
 .BY 'DO YOU LIKE TO CHANGE IT? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE JMP.NXT.LN
;
ASK JSR MESSAGE 
 CRLF
 .BY 'SELECT THE BAUDRATE: '
 STOP
 JSR ANSWER
 CMP #'0
 BCC ASK
 CMP #'6
 BCS ASK
 AND #%00001111
 STA BAUDRATE
;
 JSR MESSAGE
 CRLF
 .BY 'ASCII RECEIVER? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE SET.BAUDOT
 LDA #7
 STA BITS
 LDA #'A
 STA CODE
 JMP ASK.BUF
;
JMP.NXT.LN JMP NXT.LINE 
;
SET.BAUDOT LDA #5
 STA BITS 
 LDA #'B
 STA CODE 
ASK.BUF JSR MESSAGE 
 CRLF
 .BY 'FILE BUFFER? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE NO.BUFF
 STA BUFF.FLG
 JMP ASK.AUTO
;
NO.BUFF AND #$00 
 STA BUFF.FLG 
ASK.AUTO JSR MESSAGE 
 CRLF
 .BY 'AUTO LETTER MODE? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE NO.AUTO 
 STA AUTO.FLG 
 JMP ASK.LIST 
;
NO.AUTO AND #$00 
 STA AUTO.FLG 
ASK.LIST JSR MESSAGE 
 CRLF
 .BY 'LIST THE FILE BUFFER? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE NO.LIST
 JSR LIST.BUF
;
NO.LIST JSR MESSAGE 
 CRLF
 .BY '::'
 CRLF
 STOP
 JMP NXT.LINE
;
LINE.STRT LDA #$00 
 STA COLNR 
NXT JSR RECEIVE 
 LDX CODE 
 CPX #'B
 BNE NO.CONV 
 JSR CONVERT 
NO.CONV LDX COLNR 
 CPX MAX.COLNR 
 BCS NXT.LINE 
 CPX BELL.COLNR 
 BCC OUT.CHAR 
 CMP #$20 
 BNE OUT.CHAR 
NXT.LINE LDA #$0D 
 JSR PR/STORE 
 LDA #$0A 
 JSR PR/STORE 
 JMP LINE.STRT 
;
OUT.CHAR CMP #$0A 
 BEQ AUTO 
 CMP #$0D 
 BNE NORM.CHAR 
 LDA #$20 
NORM.CHAR JSR PR/STORE 
 INC COLNR 
AUTO LDX AUTO.FLG 
 BEQ JMP.NXT 
 CMP #$20 
 BNE JMP.NXT 
 STA BDT.MODE 
JMP.NXT JMP NXT 
;
INITIALISE SEI  
 LDA BUF.STRT 
 LDX BUF.STRT+1 
 STA *BUF.PTR 
 STX *BUF.PTR+1 
 LDY #$FF 
 TYA  
 INY  
CLR.BUFF STA (BUF.PTR),Y 
 JSR INC.BF.PTR 
 LDX BUFF.END 
 CPX *BUF.PTR 
 BNE CLR.BUFF 
 LDX BUFF.END+1 
 CPX *BUF.PTR+1 
 BNE CLR.BUFF 
 STA (BUF.PTR),Y 
 STY OVFLW.FLG 
 STY BUFF.FLG 
 LDA BUF.STRT 
 LDX BUF.STRT+1 
 STA *BUF.PTR 
 STX *BUF.PTR+1 
 LDA #L,BRK
 LDX #H,BRK
 STA JUN.BRKTST 
 STX JUN.BRKTST+1 
 LDA #L,RESET
 LDX #H,RESET
 STA JUN.NMI 
 STX JUN.NMI+1 
 LDA #%00000111
 STA PIA.PBD 
 LDA #%00111111
 STA PIA.PBDD 
 LDA #%00000000
 STA PIA.PADD 
 RTS  
;
STORE.BUF LDY OVFLW.FLG 
 BNE STO.RET 
 CMP #$00 
 BEQ STO.RET 
 LDY BUFF.FLG 
 BEQ STO.RET 
 LDY *BUF.PTR 
 CPY BUFF.END 
 BNE STORE 
 LDY *BUF.PTR+1 
 CPY BUFF.END+1 
 BEQ OVERFLOW 
STORE LDY #$00 
 STA (BUF.PTR),Y 
 JSR INC.BF.PTR 
STO.RET RTS  
;
OVERFLOW LDY #$01 
 STY OVFLW.FLG 
 JSR MSG.OVRFLW 
 JSR MESSAGE 
 CRLF
 .BY 'BUFFER OUTPUT? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE ASK.RESET
 JSR MSG.CRLF
 JSR MSG.CRLF
 JSR LIST.BUF
;
ASK.RESET JSR MESSAGE 
 CRLF
 .BY 'SYSTEM RESET? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BEQ JMP.RESET
 RTS
;
JMP.RESET JMP RESET 
;
JMP.BRK JMP BRK 
;
RECEIVE TXA  
 PHA  
 TYA  
 PHA  
 LDX BITS 
BRK.TST LDA PAD.BIT 
 AND PIA.PAD 
 BEQ JMP.BRK 
 LDA PBD.BIT 
 AND PIA.PBD 
 BNE BRK.TST 
 JSR TIM.SET/2 
 JSR DETECT 
 BCS BRK.TST 
 JSR TIM.SET/2 
WAIT.HALF LDA #$40 
 AND VIA.INTRFL 
 BEQ WAIT.HALF 
GET.BIT JSR TIM.SET 
 JSR DETECT 
 ROR CHAR 
 DEX  
 BNE GET.BIT 
 SEC  
 LDA #$08 
 SBC BITS 
 TAX  
SHIFT LSR CHAR 
 DEX  
 BNE SHIFT 
 JSR TIM.SET/4 
STOP.BIT LDA #$40 
 AND VIA.INTRFL 
 BEQ STOP.BIT 
 PLA  
 TAY  
 PLA  
 TAX  
 LDA CHAR 
 NOP  
 NOP  
 NOP  
 RTS  
;
DETECT LDA PBD.BIT 
 AND PIA.PBD 
 BEQ INC.SPCNTR 
 INC TIME.H 
 BNE TIMER 
 INC TIME.H+1 
TIMER LDA #$40 
 AND VIA.INTRFL 
 BEQ DETECT 
 SEC  
 LDA TIME.H 
 SBC TIME.L 
 LDA TIME.H+1 
 SBC TIME.L+1 
 RTS  
;
INC.SPCNTR INC TIME.L 
 BNE JMP.TIMER 
 INC TIME.L+1 
JMP.TIMER JMP TIMER 
;
TIM.SET LDA BAUDRATE 
 ASL A 
 TAY  
 LDA SPEED.TBL,Y 
 STA VIA.TIMER1 
 INY  
 LDA SPEED.TBL,Y 
 STA VIA.TIMER1+1 
CLR.TIM.LH LDA #$00 
 STA TIME.L 
 STA TIME.H 
 STA TIME.L+1 
 STA TIME.H+1 
 RTS  
;
TIM.SET/4 LDA BAUDRATE 
 ASL A 
 TAY  
 LDA SPEED.TBL,Y 
 STA TIM.TEMP 
 INY  
 LDA SPEED.TBL,Y 
 STA TIM.TEMP+1 
 LSR TIM.TEMP+1 
 ROR TIM.TEMP 
HALF LSR TIM.TEMP+1 
 ROR TIM.TEMP 
 LDA TIM.TEMP 
 STA VIA.TIMER1 
 LDA TIM.TEMP+1 
 STA VIA.TIMER1+1 
 JMP CLR.TIM.LH 
;
TIM.SET/2 LDA BAUDRATE 
 ASL A 
 TAY  
 LDA SPEED.TBL,Y 
 STA TIM.TEMP 
 INY  
 LDA SPEED.TBL,Y 
 STA TIM.TEMP+1 
 JMP HALF 
;
;
 .EN
