



   *******************************
   ***** MICRO-ADE ASSEMBLER *****
   ***** (C) COPYRIGHT  1977 *****
   ***** MICRO-WARE  LIMITED *****
   ***** 27 FIRSTBROOKE  RD. *****
   ***** TORONTO,    CANADA  *****
   *******************************




   PAGE ZERO SYMBOLS

BLO * $0010 WS POINTER
BHI * $0011
NLO * $0015 CURRENT LINE NUMBER
NHI * $0016
EOL * $0017 END OF LINE POINTER
LOPAR * $001A COMMAND INPUT PARAMETERS
HIPAR * $001D
LABEL * $0020 LABEL INPUT
OPIN * $0026 INSTRUCTION INPUT
AD * $0029 ADDRESS MODE INPUT
ARGIN * $002B ARGUMENT INPUT
YCOM * $0031 COMMENT POINTER
PLAB * $0032 PACKED LABEL
POP * $0036 PACKED INSTRUCTION
PARG * $0038 PACKED ARGUMENT
TMP * $003C TEMPORARY DATA
PCLO * $003D ASSEMBLY ADDRESS
PCHI * $003E 
SLO * $003F SYMBOL TABLE POINTER
SHI * $0040
ELO * $0041 END OF SYMBOL TABLE
EHI * $0042
SXL * $0043 TEMP SYMBOL TABLE POINTER
SXH * $0044
ADM * $0045 ADDRESS MODE
LENGTH * $0046 INSTRUCTION LENGTH
OP * $0047 OP-CODE (OBJECT BYTE 1)
OPRL * $0048 OPERAND
OPRH * $0049
PCALO * $004A OBJECT OUTPUT POINTER
PCAHI * $004B
PASS * $004C PASS FLAG
PRFLAG * $004D PRINT FLAG
SAVE * $0051 SAVE FLAG
PAGE * $0055 PAGE NUMBER
PGN * $0056 LINE IN PAGE
TITLE * $0057 TITLE
IDTEMP * $005D ID TEMPORARY
SAVX * $0062 TEMP FOR PACKT
PMODE * $0063 PAGE MODE FLAG
COUNTL * $0064 LINE COUNT
XTMP * $0065 TEMPORARY STORAGE
YTMP * $0066 TEMPORARY STORAGE
BUFFER * $0100 I/O BUFFER

INDX * $0027
SPCNT * $0028 SPACE COUNT FOR DSMBLR
XCLO * $0029 SYMBOL TABLE PTR FOR DSMBLR
XCHI * $002A
XM * $002B TEMPORARY DATA

   ASSEMBLERS SUBROUTINES IN EDITOR BLOCK

   LOAD   =            FROM WS
   BUFOUT =            BUFFER OUT 1 LINE
   ERRPRT =            PRINT ERROR
   RESTRT =            EDITOR ENTRY
   RESB   =            RESET BLO,BHI
   INCBUF =            INC BLO,BHI
   DPSYM  =            PRINT SYMBOL
   SETSY  =            SET SLO

   WORKSPACE PARAMETER DEFINITION

   SOURCE =            SOURCE DEFINITION
   SYMBOL =            SYMBOL TABLE DEFINITION
   SYMF   =            SYMBOL TABLE END
   OBJECT =            OBJECT DEFINITION

ZERO * $00
MAX * $3A
