
   ******** INPUT AND OUTPUT ROUTINES ********

   SUBROUTINE TO PRINT THE CURRENT LINE NUMBER

NOUT LDA NHI GET N
 LDX NLO AND PRINT THEM

   SUB TO PRINT 2 HEX BYTES
   FIRST BYTE IS IN A
   SECOND BYTE IS IN X

HEXAX JSR HEXOUT PRINT ACCUMULATOR
 TXA  GET BYTE IN X ... PRINT IT

   SUBROUTINE TO PRINT 1 HEX BYTE
   INPUT IS IN ACCUMULATOR

HEXOUT PHA  SAVE INPUT
 LSRA  GET
 LSRA  UPPER
 LSRA  NIBBLE
 LSRA
 JSR HEX PRINT UPPER NIBBLE
 PLA  GET INPUT BACK
 ANDIM $0F GET LOWER NIBBLE

   SUBROUTINE TO PRINT 1 HEX CHARACTER
   INPUT CHAR IS IN ACCUMULATOR

HEX CMPIM $0A LETTER OR NUMBER?
 CLC  CALCULATE ASCII
 BMI HEXA IF IT IS A NUMBER!
 ADCIM $07 ADD 7 TO LETTER
HEXA ADCIM $30 ADD 30 TO BOTH
 BNE OUTCH THEN PRINT IT

   SUBROUTINE TO PRINT CARRIAGE RETURN
   AND LINE FEED

CRLF LDAIM $0D GET CR CHARACTER
 BNE OUTCH AND PRINT IT
