
   SUBROUTINE TO FILL BUFFER FROM
   KEYBOARD INPUT

BUFIN LDYIM $00 RESET CURSOR
 STY EOL RESET END OF LINE

BUFCHA JSR INCH GET A CHAR FROM KEYBORD
 CMPIM $17 CONTROL W?
 BNE DELFNC

 LDA EOL
 CMPIM MAX EOL<MAX?
 BCS INB IF NOT DO NOTHING
 INC EOL

 TYA  SAVE CURSOR
 PHA
 LDAIM $20 SPACE ON CURSOR POSITION

EXCHGE PHA
 LDAAY BUFFER EXCHANGE ACCU
 TAX  AND
 PLA  BUFFER+Y
 STAAY BUFFER
 TXA

 INY
 CPYIM MAX Y<MAX?
 BCC EXCHGE THEN CARRY ON
 BCS SHWEOL SHOW UPDATED BUFFER

DELFNC CMPIM $11 CONTROL Q?
 BNE BSFNC
 INY
 TYA
 DEY  ACCU := Y+1
 CMP EOL Y>=EOL-1?
 BCS INB IF SO DO NOTHING
 DEC EOL
 TYA
 PHA

REPLCE LDAAY BUFFER +01
 STAAY BUFFER
 INY
 CPYIM MAX Y<MAX?
 BCC REPLCE THEN CARRY ON
 DEY
 LDAIM $20
 STAAY BUFFER

SHWEOL PLA  RESTORE CURSOR POSITION
 PHA
 TAY
 LDXIM $01 COUNTER TO RESET CURSOR

SHWNXT LDAAY BUFFER
 JSR OUTCH
 INX
 INY
 CPY EOL Y<EOL?
 BCC SHWNXT THEN CARRY ON
 JSR OUTSP

SPBACK JSR BACKSP
 DEX
 BNE SPBACK

 PLA  RESTORE CURSOR
 TAY
 BPL INB

BSFNC CMPIM $08 BS?
 BNE HTFNC
 DEY  UPDATE CURSOR
 BPL INB BUT NOT TO FAR
 INY
 LDAIM $09 THEN PRINT HT
 BNE SHWCH

HTFNC CMPIM $09 HT?
 BNE VTFNC
 JSR BACKSP FIRST PRINT A BS
 CPY EOL Y>=EOL?
 BCS INB THEN DO NOTHING
 LDAAY BUFFER
 INY
SHWCH JSR OUTCH
INB JMP BUFCHA

VTFNC CMPIM $0B VT?
 BNE OVRFNC
 LDAIM $0A JUST PRINT A LF
 BNE SHWCH

OVRFNC CMPIM $05 CONTROL E?
 BNE NEWFNC
 LDAAY BUFFER
 CMPIM $20
 BCC INB
 TYA  SAVE CURSOR
 PHA
OVR LDAAY BUFFER
 CMPIM $20
 BCC SHWEOL
 JSR INCPTS
 BCS SHWEOL
 BCC OVR

NEWFNC CMPIM $7F DEL CHAR?
 BNE LTRFNC
BASPCS JSR BACKSP
 DEY
 BNE BASPCS
 LDX EOL
 BEQ INB
 INX
ONSPCS JSR OUTSP
 INY
 DEX
 BNE ONSPCS
 STX EOL
 BEQ BASPCS

LTRFNC CMPIM $20 LETTER?
 BCC LFFNC
 STAAY BUFFER
 JSR INCPTS
 BCC INB CHAR NOT IN BUFFER+MAX
 JSR BACKSP
 JSR OUTSP
 JSR BACKSP
 CLC
 BCC INB TO GET A CR, LF OR BS

LFFNC CMPIM $0A LF?
 BNE CRFNC
 LDAIM $0B FIRST PRINT VT
 JSR OUTCH
 JSR CRLF
 LDY EOL CURSOR ON EOL
 LDAIM $0D A CR TO STOP BUFIN

CRFNC CMPIM $0D CR?
 BNE INB
 STAAY BUFFER
 RTS

INCPTS CPYIM MAX Y<MAX?
 BCS RETINC THEN RET C=1
 CPY EOL Y<EOL?
 BCC INCY
 INC EOL
INCY INY  THEN INC JUST Y
 CLC  OK THEN C=0
RETINC RTS

BACKSP LDAIM $08
 JMP OUTCH

   SUBROUTINE TO PRINT THE BUFFER

PRBUF LDYIM $00 RESET THE POINTER
PRNTB LDAAY BUFFER GET A CHARACTER
 PHA  HIDE IT TEMPORY
 JSR OUTCH PRINT IT
 PLA  SEEK IT BACK
 INY  POINT TO NEXT CHARACTER
 CMPIM $0D END OF BUFFER?
 BNE PRNTB NO, THERE MUST BE MORE
 RTS  YES, SO RETURN
