
   ***********************************************
   ***** KIM CASETTE READ AND WRITE ROUTINES *****
   ***********************************************

   CASETTE READ ERROR (INCORRECT ID)

ERID JSR HEXOUT PRINT THE WRONG ID,
 JSR OUTSP SPACE AND THEN START OVER

   ***** CASSETTE READ SUBROUTINE *****

   VERY SIMILAR TO THE READ ROUTINE
   IN THE KIM ROM.
   THE LED DISPLAY OF INCOMING DATA ADAPTED
   FROM VUTAPE, A PROGRAM BY JIM BUTTERFIELD
   FROM THE KIM-1 USER NOTES.


CREAD LDA $1702 TURN ON CASSETTE #1 BY
 ANDIM $FB CHANGING BIT 2 TO
 STA $1702 ZERO IN PIA PORT B

 LDAIM $7F TURN ON THE KIM LED DISPLAY
 STA $1741 BY SETTING THE DD REG

 CLD  JUST TO MAKE SURE

 LDAIM $8D SET UP VEB
 STA VEB TO SAVE DATA
 JSR INTVEB (IN KIM ROM)

 LDAIM $13 TURN ON INPUT PORT FROM CASETTE
 STA SBD

SYNC JSR RDBIT START READING A BIT AT A TIME

 LSR TMP SHIFT INTO TMP
 ORA TMP
 STA TMP AND SAVE IT
 STA $1740 PLACE IT ON THE LED

TST CMPIM $16 IS IT A SYNC CHARACTER?
 BNE SYNC IF NOT, KEEP TRYING

 JSR RDCHT IN SYNC, READ A CHARACTER
 STA $1740 DISPLAY IT ON LED
 CMPIM $2A IS IT THE START OF DATA?
 BNE TST IF NOT, LOOP AGAIN

 JSR RDBYT READ THE TAPE ID
 CMP ID IS IT THE RIGHT TAPE?
 BNE ERID PRINT IF WRONG

 JSR RDBYT READ THE START ADDRESS
 JSR CHKT INCLUDE IT IN CHECKSUM
 STA VEB +01 AND SAVE IT IN VEB
 JSR RDBYT READ THE HI PART OF ADDRESS
 JSR CHKT INCLUDE IN SUM
 STA VEB +02 SET IT UP IN VEB

LOADIT LDXIM $02 START TO LOAD DATA AS
READIT JSR RDCHT ASCII CHARACTERS
 CMPIM '/ END OF DATA SYMBOL
 BEQ ENDRD SO WIND IT UP

 JSR PACKT PACK THE ASCII INTO HEX
 BNE SYNC ERROR IN CHARACTER READ
 DEX  COUNT TO TWO
 BNE READIT READ SECOND HALF

 JSR CHKT ADD TO CHECKSUM
 JSR VEB STORE VIA VEB
 JSR INCVEB INCREMENT STORE ADDRESS
 JMP LOADIT AND READ NEXT BYTE

ENDRD JSR RDBYT READ CHECKSUM FROM TAPE
 CMP CHKL COMPARE TO CALCULATED
 BNE SYNC AND START OVER IF WRONG
 JSR RDBYT GET SECOND HALF OF SUM
 CMP CHKH AND DO THE SAME
 BNE SYNC WITH IT

OKRD LDA $1702 TURN OFF CASSETTE
 ORAIM $04 BY SETTING BIT 2
 STA $1702 OF THE PORT
 JMP INIT RETURN VIA INIT


