 .EJ
 .BA $B000
 .OS
;
MES.PNT .DE $F8
BUF.PTR .DE $FA
;
;
CODE .DE $20
BAUDRATE .DE $21
TIM.TEMP .DE $22
TIME.L .DE $24
TIME.H .DE $26
CHAR .DE $28
BITS .DE $29
BDT.MODE .DE $2A
BUFF.FLG .DE $2B
OVFLW.FLG .DE $2C
TMP.BF.FLG .DE $2D
AUTO.FLG .DE $2E
LIST.LNNR .DE $2F
;
;
JUN.PRCHA .DE $0D00
JUN.RECCHA .DE $0D16
VIA.TIMER1 .DE $1804
VIA.INTRFL .DE $180D
JUN.NMI .DE $1A7A
JUN.BRKTST .DE $1A7C
PIA.PAD .DE $1A80
PIA.PADD .DE $1A81
PIA.PBD .DE $1A82
PIA.PBDD .DE $1A83
;
;
!!!CRLF .MD
 .BY $0D $0A
 .ME
;
!!!LF .MD
 .BY $0A
 .ME
;
!!!STOP .MD
 .BY 0
 .ME
;
;
;
RTTY JMP RESET 
;
PBD.BIT .BY %10000000
PAD.BIT .BY %10000000
BUF.STRT .SE $2000
BUFF.END .SE $9FFF
LIST.LN/PG .BY 11 
SPEED.TBL .SE $55F0 ;45.45 BAUD
 .SE $4E20 ;50
 .SE $4488 ;57
 .SE $3415 ;75
 .SE $2710 ;100
 .SE $2383 ;110
;
 JMP BRK
;
PR/STORE NOP  
 NOP  
 NOP  
 PHA  
 CMP #$00 
 BEQ PR/ST.RET 
 JSR STORE.BUF 
 JSR JUN.PRCHA 
PR/ST.RET PLA  
 RTS  
;
BRK LDA PAD.BIT 
 AND PIA.PAD 
 BEQ BRK 
 LDX #$FF 
 TXS  
 JSR PR.STATE 
 JMP ASK.LIST 
;
ANSWER LDA *BUFF.FLG 
 PHA  
 LDA #$00 
 STA *BUFF.FLG 
 JSR JUN.RECCHA 
 JSR PR/STORE 
 TAX  
 PLA  
 STA *BUFF.FLG 
 TXA  
 RTS  
;
MESSAGE PLA  
 STA *MES.PNT 
 PLA  
 STA *MES.PNT+1 
 LDA *BUFF.FLG 
 PHA  
 LDA #$00 
 STA *BUFF.FLG 
MES.NXTCHR INC *MES.PNT 
 BNE MES.GETCHR 
 INC *MES.PNT+1 
MES.GETCHR LDY #$00 
 LDA (MES.PNT),Y 
 CMP #$00 
 BEQ MES.RET 
 JSR PR/STORE 
 JMP MES.NXTCHR 
;
MES.RET PLA  
 STA *BUFF.FLG 
 LDA *MES.PNT+1 
 PHA  
 LDA *MES.PNT 
 PHA  
 RTS  
;
MSG.BAUDOT JSR MESSAGE 
 CRLF
 .BY 'BAUDOT '
 STOP
 RTS
;
MSG.ASCII JSR MESSAGE 
 CRLF
 .BY 'ASCII '
 STOP
 RTS
;
MSG.RCEIVR JSR MESSAGE 
 .BY 'RECEIVER'
 CRLF
 STOP
 RTS
;
MSG.BAUD JSR MESSAGE 
 .BY ' BAUD'
 CRLF
 STOP
 RTS
;
MSG.45.45 JSR MESSAGE 
 .BY '45.45'
 STOP
 RTS
;
MSG.50 JSR MESSAGE 
 .BY '50'
 STOP
 RTS  
;
MSG.57 JSR MESSAGE 
 .BY '57'
 STOP
 RTS  
;
MSG.75 JSR MESSAGE 
 .BY '75'
 STOP
 RTS
;
MSG.100 JSR MESSAGE 
 .BY '100'
 STOP
 RTS  
;
MSG.110 JSR MESSAGE 
 .BY '110'
 STOP
 RTS  
;
MSG.NO JSR MESSAGE 
 .BY 'NO '
 STOP
 RTS  
;
MSG.STORED JSR MESSAGE 
  .BY 'STORAGE'
 CRLF
 STOP
 RTS
;
MSG.AUTOL JSR MESSAGE 
 .BY 'AUTO LETTER MODE'
 STOP
 RTS
;
MSG.CRLF JSR MESSAGE 
 CRLF
 STOP
 RTS  
;
LIST.BUF LDA *BUFF.FLG 
 STA *TMP.BF.FLG 
 LDA #$00 
 STA *BUFF.FLG 
 LDA BUF.STRT 
 LDX BUF.STRT+1 
 CMP *BUF.PTR 
 BNE LIST.STRT 
 CPX *BUF.PTR+1 
 BNE LIST.STRT 
 JSR MESSAGE 
 CRLF
 .BY 'FILE EMPTY'
 CRLF
 STOP
LIST.RET LDA *TMP.BF.FLG 
 STA *BUFF.FLG 
 RTS  
;
LIST.STRT STA *BUF.PTR 
 STX *BUF.PTR+1 
 JSR MSG.CRLF 
LIST.PAGE LDA #$00 
 STA *LIST.LNNR 
LIST.NXT LDY #$00 
 LDA (BUF.PTR),Y 
 CMP #$FF 
 BEQ LIST.RET 
 PHA  
 JSR PR/STORE 
 JSR INC.BF.PTR 
 SEC  
 LDA *BUF.PTR 
 SBC BUFF.END 
 LDA *BUF.PTR+1 
 SBC BUFF.END+1 
 PLA  
 BCC LIST.CR 
MSG.OVRFLW JSR MESSAGE 
 CRLF
 .BY 'FILE OVERFLOW'
 CRLF
 STOP
 RTS
;
LIST.CR CMP #$0D 
 BNE LIST.NXT 
 JSR PR/STORE 
 INC *LIST.LNNR 
 LDX *LIST.LNNR 
 CPX LIST.LN/PG 
 BCC LIST.LF 
 JSR ANSWER 
 CMP #'E
 BEQ LIST.RET 
 BNE LIST.PAGE 
LIST.LF LDA #$0A 
 CMP (BUF.PTR),Y 
 BEQ LIST.NXT 
 JSR PR/STORE 
 JMP LIST.NXT 
;
INC.BF.PTR INC *BUF.PTR 
 BNE INC.PT.RET 
 INC *BUF.PTR+1 
INC.PT.RET RTS  
;
PR.STATE JSR MSG.CRLF 
 JSR MSG.CRLF 
 LDA *CODE 
 CMP #'B
 BNE NOT.BAUDOT 
 JSR MSG.BAUDOT 
 JMP PR.RCVR 
;
NOT.BAUDOT JSR MSG.ASCII 
PR.RCVR JSR MSG.RCEIVR 
 LDA *BAUDRATE 
 BNE NOT.45.45 
 JSR MSG.45.45 
 JMP PR.BAUD 
;
NOT.45.45 CMP #$01 
 BNE NOT.50 
 JSR MSG.50 
 JMP PR.BAUD 
;
NOT.50 CMP #$02 
 BNE NOT.57 
 JSR MSG.57 
 JMP PR.BAUD 
;
NOT.57 CMP #$03 
 BNE NOT.75 
 JSR MSG.75 
 JMP PR.BAUD 
;
NOT.75 CMP #$04 
 BNE NOT.100 
 JSR MSG.100 
 JMP PR.BAUD 
;
NOT.100 JSR MSG.110 
PR.BAUD JSR MSG.BAUD 
 LDA *BUFF.FLG 
 BEQ PR.NOSTO 
PR.STORED JSR MSG.STORED 
 LDA *AUTO.FLG 
 BEQ PR.NOAUTO 
PR.AUTO JSR MSG.AUTOL 
 RTS  
;
PR.NOSTO JSR MSG.NO 
 JMP PR.STORED 
;
PR.NOAUTO JSR MSG.NO 
 JMP PR.AUTO 
;
CONVERT CMP #$1F 
 BEQ SET.LTRS 
 CMP #$1B 
 BEQ SET.FIGS 
 LDX *BDT.MODE 
 BEQ GET.FIG 
 TAX  
 LDA LETTERS,X 
 RTS  
;
GET.FIG TAX  
 LDA FIGURES,X 
 RTS  
;
SET.FIGS LDA #$00 
 STA *BDT.MODE 
 RTS  
;
SET.LTRS STA *BDT.MODE 
 LDA #$00 
 RTS  
;
LETTERS .BY $00  
 .BY 'E'
 .BY $0A
 .BY 'A'
 .BY ' '
 .BY 'S' 
 .BY 'I' 
 .BY 'U' 
 .BY $0D 
 .BY 'D'
 .BY 'R' 
 .BY 'J' 
 .BY 'N' 
 .BY 'F' 
 .BY 'C' 
 .BY 'K' 
 .BY 'T' 
 .BY 'Z'
 .BY 'L' 
 .BY 'W' 
 .BY 'H' 
 .BY 'Y' 
 .BY 'P'
 .BY 'Q'
 .BY 'O' 
 .BY 'B' 
 .BY 'G' 
 .BY $00 
 .BY 'M' 
 .BY 'X' 
 .BY 'V' 
 .BY $00 
FIGURES .BY $00  
 .BY '3' 
 .BY $0A 
 .BY '-' 
 .BY ' ' 
 .BY $27 ;'
 .BY '8' 
 .BY '7' 
 .BY $0D 
 .BY $00 
 .BY '4' 
 .BY $07 
 .BY ',' 
 .BY '%' 
 .BY ':' 
 .BY '(' 
 .BY '5' 
 .BY '+' 
 .BY ')' 
 .BY '2' 
 .BY '$' 
 .BY '6' 
 .BY '0' 
 .BY '1' 
 .BY '9' 
 .BY '?' 
 .BY '&' 
 .BY $00 
 .BY '.' 
 .BY '/' 
 .BY '=' 
 .BY $00 
RESET JSR INITIALISE 
 LDX #$FF 
 TXS  
 LDA #5
 STA *BITS 
 LDA #'B
 STA *CODE 
 LDX #$01 
 STX *BAUDRATE 
 STX *BDT.MODE 
 STX *BUFF.FLG 
 DEX
 STX *AUTO.FLG 
 JSR MESSAGE 
 CRLF
 .BY 'BAUDRATE: 0=45.45 1=50 2=57 3=75 4=100 5=110'
 CRLF
 .BY 'ANY CHANGE? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE JMP.NXT.LN
;
ASK JSR MESSAGE 
 CRLF
 .BY 'SELECT THE BAUDRATE: '
 STOP
 JSR ANSWER
 CMP #'0
 BCC ASK
 CMP #'6
 BCS ASK
 AND #%00001111
 STA *BAUDRATE
;
 JSR MESSAGE
 CRLF
 .BY 'ASCII RECEIVER? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE SET.BAUDOT
 LDA #7
 STA *BITS
 LDA #'A
 STA *CODE
 JMP ASK.BUF
;
JMP.NXT.LN JMP NXT.LINE 
;
SET.BAUDOT LDA #5
 STA *BITS 
 LDA #'B
 STA *CODE 
ASK.BUF JSR MESSAGE 
 CRLF
 .BY 'FILE BUFFER? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE NO.BUFF
 STA *BUFF.FLG
 JMP ASK.AUTO
;
NO.BUFF AND #$00 
 STA *BUFF.FLG 
ASK.AUTO JSR MESSAGE 
 CRLF
 .BY 'AUTO LETTER MODE? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE NO.AUTO 
 STA *AUTO.FLG 
 JMP ASK.LIST 
;
NO.AUTO AND #$00 
 STA *AUTO.FLG 
ASK.LIST JSR MESSAGE 
 CRLF
 .BY 'LIST THE FILE BUFFER? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE NO.LIST
 JSR LIST.BUF
;
NO.LIST JSR MESSAGE 
 CRLF
 .BY '::'
 CRLF
 STOP
;
NXT.LINE LDA #$0A
 JSR PR/STORE
 LDA #$0D
 JSR PR/STORE
;
NXT JSR RECEIVE
 LDX *CODE
 CPX #'B
 BNE ASCII
 JSR CONVERT
ASCII LDX *AUTO.FLG
 BEQ OUT.CHAR
 CMP #' 
 BNE OUT.CHAR
 STA *BDT.MODE
OUT.CHAR JSR PR/STORE
 JMP NXT
;
INITIALISE SEI  
 LDA BUF.STRT 
 LDX BUF.STRT+1 
 STA *BUF.PTR 
 STX *BUF.PTR+1 
 LDY #$FF 
 TYA  
 INY  
CLR.BUFF STA (BUF.PTR),Y 
 JSR INC.BF.PTR 
 LDX BUFF.END 
 CPX *BUF.PTR 
 BNE CLR.BUFF 
 LDX BUFF.END+1 
 CPX *BUF.PTR+1 
 BNE CLR.BUFF 
 STA (BUF.PTR),Y 
 STY *OVFLW.FLG 
 STY *BUFF.FLG 
 LDA BUF.STRT 
 LDX BUF.STRT+1 
 STA *BUF.PTR 
 STX *BUF.PTR+1 
 LDA #L,BRK
 LDX #H,BRK
 STA JUN.BRKTST 
 STX JUN.BRKTST+1 
 LDA #L,RESET
 LDX #H,RESET
 STA JUN.NMI 
 STX JUN.NMI+1 
 LDA #%00000111
 STA PIA.PBD 
 LDA #%00111111
 STA PIA.PBDD 
 LDA #%00000000
 STA PIA.PADD 
 RTS  
;
STORE.BUF LDY *OVFLW.FLG 
 BNE STO.RET 
 CMP #$00 
 BEQ STO.RET 
 LDY *BUFF.FLG 
 BEQ STO.RET 
 LDY *BUF.PTR 
 CPY BUFF.END 
 BNE STORE 
 LDY *BUF.PTR+1 
 CPY BUFF.END+1 
 BEQ OVERFLOW 
STORE LDY #$00 
 STA (BUF.PTR),Y 
 JSR INC.BF.PTR 
STO.RET RTS  
;
OVERFLOW LDY #$01 
 STY *OVFLW.FLG 
 JSR MSG.OVRFLW 
 JSR MESSAGE 
 CRLF
 .BY 'BUFFER OUTPUT? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BNE ASK.RESET
 JSR MSG.CRLF
 JSR MSG.CRLF
 JSR LIST.BUF
;
ASK.RESET JSR MESSAGE 
 CRLF
 .BY 'SYSTEM RESET? <Y/N>'
 STOP
 JSR ANSWER
 CMP #'Y
 BEQ JMP.RESET
 RTS
;
JMP.RESET JMP RESET 
;
JMP.BRK JMP BRK 
;
RECEIVE TXA  
 PHA  
 TYA  
 PHA  
 LDX *BITS 
BRK.TST LDA PAD.BIT 
 AND PIA.PAD 
 BEQ JMP.BRK 
 LDA PBD.BIT 
 AND PIA.PBD 
 BNE BRK.TST 
 JSR TIM.SET/2 
 JSR DETECT 
 BCS BRK.TST 
 JSR TIM.SET/2 
WAIT.HALF LDA #$40 
 AND VIA.INTRFL 
 BEQ WAIT.HALF 
GET.BIT JSR TIM.SET 
 JSR DETECT 
 ROR *CHAR 
 DEX  
 BNE GET.BIT 
 SEC  
 LDA #$08 
 SBC *BITS 
 TAX  
SHIFT LSR *CHAR 
 DEX  
 BNE SHIFT 
 JSR TIM.SET/4 
STOP.BIT LDA #$40 
 AND VIA.INTRFL 
 BEQ STOP.BIT 
 PLA  
 TAY  
 PLA  
 TAX  
 LDA *CHAR 
 NOP  
 NOP  
 NOP  
 RTS  
;
DETECT LDA PBD.BIT 
 AND PIA.PBD 
 BEQ INC.SPCNTR 
 INC *TIME.H 
 BNE TIMER 
 INC *TIME.H+1 
TIMER LDA #$40 
 AND VIA.INTRFL 
 BEQ DETECT 
 SEC  
 LDA *TIME.H 
 SBC *TIME.L 
 LDA *TIME.H+1 
 SBC *TIME.L+1 
 RTS  
;
INC.SPCNTR INC *TIME.L 
 BNE JMP.TIMER 
 INC *TIME.L+1 
JMP.TIMER JMP TIMER 
;
TIM.SET LDA *BAUDRATE 
 ASL A 
 TAY  
 LDA SPEED.TBL,Y 
 STA VIA.TIMER1 
 INY  
 LDA SPEED.TBL,Y 
 STA VIA.TIMER1+1 
CLR.TIM.LH LDA #$00 
 STA *TIME.L 
 STA *TIME.H 
 STA *TIME.L+1 
 STA *TIME.H+1 
 RTS  
;
TIM.SET/4 LDA *BAUDRATE 
 ASL A 
 TAY  
 LDA SPEED.TBL,Y 
 STA *TIM.TEMP 
 INY  
 LDA SPEED.TBL,Y 
 STA *TIM.TEMP+1 
 LSR *TIM.TEMP+1 
 ROR *TIM.TEMP 
HALF LSR *TIM.TEMP+1 
 ROR *TIM.TEMP 
 LDA *TIM.TEMP 
 STA VIA.TIMER1 
 LDA *TIM.TEMP+1 
 STA VIA.TIMER1+1 
 JMP CLR.TIM.LH 
;
TIM.SET/2 LDA *BAUDRATE 
 ASL A 
 TAY  
 LDA SPEED.TBL,Y 
 STA *TIM.TEMP 
 INY  
 LDA SPEED.TBL,Y 
 STA *TIM.TEMP+1 
 JMP HALF 
;
;
 .EN
