SCREEN ORG $6000

   DEFINITIONS

POINTL * $00FE
POINTH * $00FF
ADREG * $B7FE ADDRESS REGISTER
DAREG * $B7FF SELECTED REGISTER
VIDEO * $B800 FIRST VIDEO RAM LOC
VIDOFF * $C000 LAST VIDEO RAM + 1

TEST JSR PRESET
TST1 JSR CLEAR
 BRK

PRESET LDXIM $0B
SET LDAAX REGTAB
 STX ADREG
 STA DAREG
 DEX
 BPL SET
 RTS

REGTAB = $64 100 HORIZONTAL TOTAL
 = $50  80 CHARS/ROW
 = $4F  79 HSYNC POSITION
 = $33     HSYNC/VSYNC WIDTH
 = $1C  28 VERTICAL TOTAL
 = $03   3 VERTICAL ADJUST
 = $19  25 CHAR ROWS/FRAME
 = $1B  27
 = $00   0 MODE
 = $0B  12 SCAN LINES/ROW
 = $6B     CURSOR START LINE/BLINKING
 = $0B     CURSOR STOP LINE

CLEAR LDAIM VIDEO
 LDXIM VIDEO /
 STA POINTL
 STX POINTH
 LDXIM VIDOFF /
 LDYIM $00
CLE0 LDAIM $1F
CLE1 CLC
 ADCIM $01
 CMPIM $C0
 BEQ CLE0
 STAIY POINTL
 INC POINTL
 BNE CLE1
 INC POINTH
 CPX POINTH
 BNE CLE1
 RTS
